export interface UseResolveCallOptions {
    autoFetch?: boolean;
}
export declare type ResolveCallParams = Record<string, unknown>;
export interface ResolveCallOptions<Result extends unknown, Params extends ResolveCallParams> {
    onError?: (error: Error) => void;
    onSuccess?: (results: Result) => void;
    onComplete?: () => void;
    throwOnError?: boolean;
    params?: Params;
}
export declare const _useResolveCall: <Result extends unknown, Params extends ResolveCallParams = Record<string, unknown>>(call: (params: Params) => Promise<Result>, initialData: Result, params?: Params | undefined, options?: UseResolveCallOptions | undefined) => {
    fetch: ({ throwOnError, onComplete, onError, onSuccess, params: fetchParams, }?: ResolveCallOptions<Result, Params>) => Promise<void>;
    isFetching: boolean;
    isLoading: boolean;
    error: Error | null;
    data: Result;
    setData: (f: Result | ((draft: Result | import("immer").Draft<Result>) => void)) => void;
};
